precision highp float;

uniform sampler2D inputImageTexture;

uniform vec2 singleStepOffset;

varying highp vec2 textureCoordinate;

const highp vec3 W = vec3(0.299,0.587,0.114);  //YUV 转换

//[[ 0.01772097  0.01899533  0.01980352  0.02008049  0.01980352  0.01899533 0.01772097]
// [ 0.01899533  0.02036133  0.02122764  0.02152453  0.02122764  0.02036133 0.01899533]
// [ 0.01980352  0.02122764  0.02213081  0.02244033  0.02213081  0.02122764 0.01980352]
// [ 0.02008049  0.02152453  0.02244033  0.02275418  0.02244033  0.02152453 0.02008049]
// [ 0.01980352  0.02122764  0.02213081  0.02244033  0.02213081  0.02122764 0.01980352]
// [ 0.01899533  0.02036133  0.02122764  0.02152453  0.02122764  0.02036133 0.01899533]
// [ 0.01772097  0.01899533  0.01980352  0.02008049  0.01980352  0.01899533 0.01772097]]

vec3 toYUV(vec3 color) {
    return vec3(
        dot(color, W),
        -0.149 * color.r - 0.331 * color.g + 0.5 * color.b + 0.5,
        0.5 * color.r - 0.419 * color.g - 0.081 * color.b + 0.5
    );
}

float toVV(vec3 color) {
    return 0.5 * color.r - 0.419 * color.g - 0.081 * color.b + 0.5;
}

void main(){
    vec3 gauess = texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-3.0, -3.0)).rgb * 0.01772097
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-3.0, -2.0)).rgb * 0.01899533
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-3.0, -1.0)).rgb * 0.01980352
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-3.0, 0.0)).rgb * 0.02008049
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-3.0, 1.0)).rgb * 0.01980352
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-3.0, 2.0)).rgb * 0.01899533
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-3.0, 3.0)).rgb * 0.01772097

                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-2.0, -3.0)).rgb * 0.01899533
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-2.0, -2.0)).rgb * 0.02036133
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-2.0, -1.0)).rgb * 0.02122764
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-2.0, 0.0)).rgb * 0.02152453
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-2.0, 1.0)).rgb * 0.02122764
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-2.0, 2.0)).rgb * 0.02036133
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-2.0, 3.0)).rgb * 0.01899533

                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-1.0, -3.0)).rgb * 0.01980352
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-1.0, -2.0)).rgb * 0.02122764
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-1.0, -1.0)).rgb * 0.02213081
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-1.0, 0.0)).rgb * 0.02244033
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-1.0, 1.0)).rgb * 0.02213081
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-1.0, 2.0)).rgb * 0.02122764
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-1.0, 3.0)).rgb * 0.01980352

                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(0.0, -3.0)).rgb * 0.02008049
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(0.0, -2.0)).rgb * 0.02152453
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(0.0, -1.0)).rgb * 0.02244033
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(0.0, 0.0)).rgb * 0.02275418
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(0.0, 1.0)).rgb * 0.02244033
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(0.0, 2.0)).rgb * 0.02152453
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(0.0, 3.0)).rgb * 0.02008049

                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(1.0, -3.0)).rgb * 0.01980352
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(1.0, -2.0)).rgb * 0.02122764
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(1.0, -1.0)).rgb * 0.02213081
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(1.0, 0.0)).rgb * 0.02244033
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(1.0, 1.0)).rgb * 0.02213081
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(1.0, 2.0)).rgb * 0.02122764
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(1.0, 3.0)).rgb * 0.01980352

                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(2.0, -3.0)).rgb * 0.01899533
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(2.0, -2.0)).rgb * 0.02036133
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(2.0, -1.0)).rgb * 0.02122764
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(2.0, 0.0)).rgb * 0.02152453
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(2.0, 1.0)).rgb * 0.02122764
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(2.0, 2.0)).rgb * 0.02036133
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(2.0, 3.0)).rgb * 0.01899533

                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(3.0, -3.0)).rgb * 0.01772097
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(3.0, -2.0)).rgb * 0.01899533
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(3.0, -1.0)).rgb * 0.01980352
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(3.0, 0.0)).rgb * 0.02008049
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(3.0, 1.0)).rgb * 0.01980352
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(3.0, 2.0)).rgb * 0.01899533
                  + texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(3.0, 3.0)).rgb * 0.01772097;

//    vec3 centralColor = texture2D(inputImageTexture, textureCoordinate.xy).rgb;
//    float sourceV = toVV(centralColor) * 256.0;
//
//    float logvv = log(sourceV) - log(vvGauess * 256.0);
//
//    logvv = (logvv - (-0.03764)) / (2.54126 - (-0.03764));
//
////    logyy = (logyy - (-0.03764)) / (2.54126 - (-0.03764));
//    float yy = logvv;
////    float vv = exp(logvv) / 256.0;
//    float uu = -0.149 * centralColor.r - 0.331 * centralColor.g + 0.5 * centralColor.b + 0.5;
//    float vv = 0.5 * centralColor.r - 0.419 * centralColor.g - 0.081 * centralColor.b + 0.5;
//    vec3 smoothColor = vec3(
//        yy - 0.00093 * (uu - 0.5) + 1.401687 * (vv - 0.5),
//        yy - 0.3437 * (uu - 0.5) - 0.71417 * (vv - 0.5),
//        yy + 1.77216 * (uu - 0.5) + 0.00099 * (vv - 0.5)
//    );
    gl_FragColor = vec4(gauess, 1.0);

//    float yy = centralColorY;
//    float uu = -0.149 * centralColor.r - 0.331 * centralColor.g + 0.5 * centralColor.b + 0.5;
//    float vv = 0.5 * centralColor.r - 0.419 * centralColor.g - 0.081 * centralColor.b + 0.5;
//    vec3 centralColor = texture2D(inputImageTexture, textureCoordinate).rgb;
//    float centralColorY = dot(centralColor, W);
//    float skinAlpha = getSkinAlpha();  //羽化边缘
//    if (skinAlpha > 0.002) {
//        float yy =  centralColorY * 8.0
//                  - dot(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-1.0, -1.0)).rgb, W)
//                  - dot(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(-1.0, 1.0)).rgb, W)
//                  - dot(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(1.0, -1.0)).rgb, W)
//                  - dot(texture2D(inputImageTexture, textureCoordinate.xy + singleStepOffset * vec2(1.0, 1.0)).rgb, W);
//        yy = yy / 4.0;
//
//        yy = mix(centralColorY, yy, skinAlpha);
////        float yy = centralColorY;
//        float uu = -0.149 * centralColor.r - 0.331 * centralColor.g + 0.5 * centralColor.b + 0.5;
//        float vv = 0.5 * centralColor.r - 0.419 * centralColor.g - 0.081 * centralColor.b + 0.5;
//        vec3 smoothColor = vec3(
//            yy - 0.00093 * (uu - 0.5) + 1.401687 * (vv - 0.5),
//            yy - 0.3437 * (uu - 0.5) - 0.71417 * (vv - 0.5),
//            yy + 1.77216 * (uu - 0.5) + 0.00099 * (vv - 0.5)
//        );
//        gl_FragColor = vec4(smoothColor, 1.0);
//    } else {
//        gl_FragColor = vec4(centralColor, 1.0);
//    }
}